Package ec.eda.dovs

# Class HyperboxSpecies

java.lang.Object
ec.Species
ec.vector.VectorSpecies
ec.vector.IntegerVectorSpecies
ec.eda.dovs.DOVSSpecies
ec.eda.dovs.HyperboxSpecies

All Implemented Interfaces:
  `Prototype`, `Setup`, `Serializable`, `Cloneable`

public class HyperboxSpecies extends DOVSSpecies
HyperboxSpecies is a DOVSSpecies which contains method for updating promising sample area and also sample from that area.

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `ArrayList<double[]>`
  `boxA`
  boxA and boxB contain the current constraint hyperbox.
  `ArrayList<Double>`
  `boxB`
  boxA and boxB contain the current constraint hyperbox.
  `static double`
  `EPSILON_STABILITY`
  `static double`
  `LARGE_NUMBER`
  `static double`
  `UPPER_BOUND`

  ### Fields inherited from class ec.eda.dovs.DOVSSpecies

  `A, activeSolutions, b, corners, Ek, initialReps, numOfTotalSamples, optimalIndex, P_A, P_B, P_CONSTRAINTS_SIZE, P_DOVS_SPECIES, P_INITIAL_REPETITION, P_STOCHASTIC, P_WARM_UP, repetition, stochastic, visited, visitedIndexMap, warmUp`

  ### Fields inherited from class ec.vector.IntegerVectorSpecies

  `C_RANDOM_WALK_MUTATION, C_RESET_MUTATION, maxGene, minGene, mutationIsBounded, mutationType, P_MAXGENE, P_MINGENE, P_MUTATION_BOUNDED, P_MUTATIONTYPE, P_NUM_SEGMENTS, P_RANDOM_WALK_PROBABILITY, P_SEGMENT, P_SEGMENT_END, P_SEGMENT_START, P_SEGMENT_TYPE, randomWalkProbability, V_RANDOM_WALK_MUTATION, V_RESET_MUTATION`

  ### Fields inherited from class ec.vector.VectorSpecies

  `C_ANY_POINT, C_GEOMETRIC, C_INTERMED_RECOMB, C_LINE_RECOMB, C_NONE, C_ONE_POINT, C_ONE_POINT_NO_NOP, C_SIMULATED_BINARY, C_TWO_POINT, C_TWO_POINT_NO_NOP, C_UNIFORM, chunksize, crossoverDistributionIndex, crossoverProbability, crossoverType, duplicateRetries, dynamicInitialSize, genomeIncreaseProbability, genomeResizeAlgorithm, genomeSize, lineDistance, maxInitialSize, minInitialSize, mutationProbability, P_CHUNKSIZE, P_CROSSOVER_DISTRIBUTION_INDEX, P_CROSSOVERPROB, P_CROSSOVERTYPE, P_DUPLICATE_RETRIES, P_GENOMESIZE, P_GEOMETRIC_PROBABILITY, P_LINEDISTANCE, P_MUTATIONPROB, P_UNIFORM_MAX, P_UNIFORM_MIN, P_VECTORSPECIES, V_ANY_POINT, V_GEOMETRIC, V_INTERMED_RECOMB, V_LINE_RECOMB, V_ONE_POINT, V_ONE_POINT_NO_NOP, V_SIMULATED_BINARY, V_TWO_POINT, V_TWO_POINT_NO_NOP, V_UNIFORM`

  ### Fields inherited from class ec.Species

  `f_prototype, i_prototype, P_FITNESS, P_INDIVIDUAL, P_PIPE, pipe_prototype`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `HyperboxSpecies()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `ArrayList<Individual>`
  `mostPromisingAreaSamples(EvolutionState state, int popSize)`
  Sample from the hyperbox to get new samples for evaluation.
  `void`
  `setup(EvolutionState state, Parameter base)`
  The default version of setup(...) loads requested pipelines and calls setup(...) on them and normalizes their probabilities.
  `void`
  `updateMostPromisingArea(EvolutionState state)`
  Constructing a hyperbox, which defines the next search area.

  ### Methods inherited from class ec.eda.dovs.DOVSSpecies

  `defaultBase, findBestSample, uniqueSamples`

  ### Methods inherited from class ec.vector.IntegerVectorSpecies

  `inNumericalTypeRange, inNumericalTypeRange, loadParametersForGene, maxGene, minGene, mutationIsBounded, mutationType, randomWalkProbability`

  ### Methods inherited from class ec.vector.VectorSpecies

  `contains, contains, contains, contains, duplicateRetries, fill, fill, fill, fill, initializeGenomeSegmentsByEndIndices, initializeGenomeSegmentsByStartIndices, mutationProbability, newIndividual, setupGenome`

  ### Methods inherited from class ec.Species

  `buildMisc, clone, newIndividual, newIndividual, updateIndividual, updateSubpopulation`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### boxA

    public ArrayList<double[]> boxA
    boxA and boxB contain the current constraint hyperbox.

  - ### boxB

    public ArrayList<Double> boxB
    boxA and boxB contain the current constraint hyperbox.

  - ### UPPER_BOUND

    public static double UPPER_BOUND

  - ### EPSILON_STABILITY

    public static double EPSILON_STABILITY

  - ### LARGE_NUMBER

    public static double LARGE_NUMBER

- ## Constructor Details

  - ### HyperboxSpecies

    public HyperboxSpecies()

- ## Method Details

  - ### setup

    public void setup(EvolutionState state, Parameter base)
    Description copied from class: `Species`
    The default version of setup(...) loads requested pipelines and calls setup(...) on them and normalizes their probabilities. If your individual prototype might need to know special things about the species (like parameters stored in it), then when you override this setup method, you'll need to set those parameters BEFORE you call super.setup(...), because the setup(...) code in Species sets up the prototype.
    Specified by:
      `setup` in interface `Prototype`
    Specified by:
      `setup` in interface `Setup`
    Overrides:
      `setup` in class `DOVSSpecies`
    See Also:
      - `Prototype.setup(EvolutionState,Parameter)`

  - ### updateMostPromisingArea

    public void updateMostPromisingArea(EvolutionState state)
    Constructing a hyperbox, which defines the next search area.
    Overrides:
      `updateMostPromisingArea` in class `DOVSSpecies`

  - ### mostPromisingAreaSamples

    public ArrayList<Individual> mostPromisingAreaSamples(EvolutionState state, int popSize)
    Sample from the hyperbox to get new samples for evaluation.
    Overrides:
      `mostPromisingAreaSamples` in class `DOVSSpecies`